//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_color3  Gold
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string DmiParams = "2,45;3,40;50,25;";

//
//
//
//
//

double buffer0[];
double buffer1[];
double buffer2[];
int    periods[];
double levels[];
int    size;

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer0); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer1); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer2); SetIndexStyle(2,DRAW_HISTOGRAM);

      //
      //
      //
      //
      //
      
      DmiParams = StringTrimLeft(StringTrimRight(DmiParams));
      if (StringSubstr(DmiParams,StringLen(DmiParams),1) != ";")
                       DmiParams = StringConcatenate(DmiParams,";");

         //
         //
         //
         //
         //                                   
            
         int n,m,s = 0;
         int i = StringFind(DmiParams,";",s);
         while (i > 0)
         {
            string current = StringSubstr(DmiParams,s,i-s);
            if (current!=";")
            {
               size = ArraySize(periods)+1;
                      ArrayResize(periods ,size);
                      ArrayResize(levels,size);
                        n = StringFind(current,",",0); periods[size-1] = StrToInteger(StringSubstr(current,0,n));  m = n+1;
                        n = StringFind(current,",",m);  levels[size-1] = StrToDouble(StringSubstr(current,m,n-m)); m = n+1; 
            }
            s = i + 1;
            i = StringFind(DmiParams,";",s);
         }
         
         //
         //
         //
         //
         //
         
   IndicatorShortName("DMI summed "+size);
   return(0);
}

//
//
//
//
//

int deinit()
{
   return (0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit  = MathMin(Bars-counted_bars,Bars-1);
         

   for(int i=limit; i>=0; i--)
   {
      int sum=0;
      for (int k=0; k<size; k++)
      {
         double adxplus  = iCustom(NULL,0,"Wilder\'s DMI book",periods[k],0,i);
         double adxminus = iCustom(NULL,0,"Wilder\'s DMI book",periods[k],1,i);
         
            if (adxplus  > levels[k]) sum += 1;
            if (adxminus > levels[k]) sum -= 1;
      }
      buffer0[i] = EMPTY_VALUE;
      buffer1[i] = EMPTY_VALUE;
      buffer2[i] = EMPTY_VALUE;
         if (sum== size) { buffer0[i] = 1; continue; }
         if (sum==-size) { buffer1[i] = 1; continue; }
                           buffer2[i] = 1;
   }     
   return(0);
}


